<template>
  <div class="editor">
    <label class="q-mb-sm block">{{label}}</label>
    <editor-menu-bar :editor="editor" v-slot="{ commands, isActive }">
      <div class="menubar">
        <q-btn-group>
          <q-btn
            :color="isActive.bold() ? 'blue-6' : 'white'"
            :text-color="isActive.bold() ? 'white' : 'blue-6'"
            icon="format_bold"
            class="menubar__button"
            @click="commands.bold"
          />
          <q-btn
            :color="isActive.italic() ? 'blue-6' : 'white'"
            :text-color="isActive.italic() ? 'white' : 'blue-6'"
            icon="format_italic"
            class="menubar__button"
            @click="commands.italic"
          />
          <q-btn
            :color="isActive.strike() ? 'blue-6' : 'white'"
            :text-color="isActive.strike() ? 'white' : 'blue-6'"
            icon="format_strikethrough"
            class="menubar__button"
            @click="commands.strike"
          />
          <q-btn
            :color="isActive.underline() ? 'blue-6' : 'white'"
            :text-color="isActive.underline() ? 'white' : 'blue-6'"
            icon="format_underline"
            class="menubar__button"
            @click="commands.underline"
          />
          <q-btn
            :color="isActive.heading({ level: 1 }) ? 'blue-6' : 'white'"
            :text-color="isActive.heading({ level: 1 }) ? 'white' : 'blue-6'"
            label="H1"
            class="menubar__button"
            @click="commands.heading({ level: 1 })"
          />
          <q-btn
            :color="isActive.heading({ level: 2 }) ? 'blue-6' : 'white'"
            :text-color="isActive.heading({ level: 2 }) ? 'white' : 'blue-6'"
            label="H2"
            class="menubar__button"
            @click="commands.heading({ level: 2 })"
          />
          <q-btn
            :color="isActive.heading({ level: 3 }) ? 'blue-6' : 'white'"
            :text-color="isActive.heading({ level: 3 }) ? 'white' : 'blue-6'"
            label="H3"
            class="menubar__button"
            @click="commands.heading({ level: 3 })"
          />
          <q-btn
            :color="isActive.bullet_list() ? 'blue-6' : 'white'"
            :text-color="isActive.bullet_list() ? 'white' : 'blue-6'"
            icon="format_list_bulleted"
            class="menubar__button"
            @click="commands.bullet_list"
          />
          <q-btn
            :color="isActive.ordered_list() ? 'blue-6' : 'white'"
            :text-color="isActive.ordered_list() ? 'white' : 'blue-6'"
            icon="format_list_numbered"
            class="menubar__button"
            @click="commands.ordered_list"
          />
          <q-btn
            :color="isActive.blockquote() ? 'blue-6' : 'white'"
            :text-color="isActive.blockquote() ? 'white' : 'blue-6'"
            icon="format_quote"
            class="menubar__button"
            @click="commands.blockquote"
          />
        </q-btn-group>
      </div>
    </editor-menu-bar>
    <editor-content :editor="editor" class="editor-content" />
  </div>
</template>

<script>
import { Editor, EditorContent, EditorMenuBar } from 'tiptap';
import {
  Blockquote,
  Heading,
  OrderedList,
  BulletList,
  ListItem,
  Bold,
  Italic,
  Link,
  Strike,
  Underline
} from 'tiptap-extensions';
import { CommonUtils } from '~/utils';

export default {
  props: {
    label: { type: String, default: '' },
    value: { type: String, default: '' }
  },
  components: { EditorContent, EditorMenuBar },
  data() {
    return {
      editor: null
    };
  },
  mounted() {
    this.editor = new Editor({
      extensions: [
        new Blockquote(),
        new BulletList(),
        new Heading({ levels: [1, 2, 3] }),
        new ListItem(),
        new OrderedList(),
        new Link(),
        new Bold(),
        new Italic(),
        new Strike(),
        new Underline()
      ],
      content: '',
      onUpdate: this.onUpdate
    });
    this.editor.setContent(CommonUtils.decodeHtml(this.value));
  },
  beforeDestroy() {
    this.editor.destroy();
  },
  methods: {
    onUpdate() {
      this.$emit('input', this.editor.getHTML());
    }
  }
};
</script>

<style lang="scss" scoped>
.editor-content {
  border: 1px solid rgba(0, 0, 0, 0.15);
  padding: 15px;

  /deep/ .ProseMirror {
    outline: none !important;
    min-height: 500px;
  }
}
</style>
